import java.util.*;
import java.io.*;

public class NumeraSorgenti
{
	public static void main(String[] argv)
	{
		if(argv.length < 1)
		{
			System.err.println("USAGE: java NumeraSorgenti <fileIn> [fileOut]");
			System.exit(1);
		}

		NumeraSorgenti ns = new NumeraSorgenti();
		if(argv.length > 1)
		{
			ns.numera(argv[0], argv[1]);
		}
		else
		{
			ns.numera(argv[0]);
		}
	}

	public void numera(String fileIn, String fileOut)
	{
		ArrayList<String> buffer = new ArrayList<String>();
		System.out.println("FileIn: " + fileIn + "; FileOut: " + fileOut);
		Scanner s = null;
		PrintWriter pw = null;

		File f = new File(fileIn);

		try
		{
			s = new Scanner(f);
			pw = new PrintWriter(fileOut);
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			System.exit(1);
		}
		
		//while(s.hasNextLine())
		while(s.hasNext())
		{
			String linea = s.nextLine();
			buffer.add(linea);
			System.out.println(linea);
		}
		int pad = (int)Math.round(Math.floor(Math.log10(buffer.size())));
		pad++;
		s.close();

		Iterator<String> iter = buffer.iterator();
		int numLin = 1;
		int k;
		while(iter.hasNext())
		{
			String linea = iter.next();
			pw.print(numLin);
			for(k = pad; k > (int)Math.round(Math.floor(Math.log10(numLin))); k--)
			{
				pw.print(" ");
			}
			pw.println(linea);
			numLin++;
		}

		pw.close();
	}

	public void numera(String fileIn)
	{
		numera(fileIn, (fileIn + ".numerato"));
	}
}
