package comparabili;

import java.util.*;
import java.io.*;

public class Studente
implements Comparable<Studente>
{
	String cognome;
	String nome;
	int matricola;
	Goliardia gol;

	public int compareTo(Studente s)
	{
		return matricola - s.matricola;
	}

	//precondizione: lo scanner deve permettermi di leggere due stringhe ed un numero
	public boolean popolaCampi(Scanner s)
	{
		cognome = s.nextLine();
		nome = s.nextLine();
		matricola = Integer.parseInt(s.nextLine());
		gol = new Goliardia(s.nextLine());
		return true;
	}

	public boolean equals(Object o)
	{
		Studente s = (Studente)o;
		return compareTo(s) == 0;
	}

	public String toString()
	{
		return cognome + " " + nome + " " + matricola + " Goliardia " + gol;
	}

	public static void main(String[] argv)
	{
		Map<Integer, Studente>studenti = new HashMap<Integer, Studente>();
		//Map<Goliardia, Studente>studentiPerGoliardia = new HashMap<Goliardia, Studente>();
		Map<Goliardia, Studente>studentiPerGoliardia = new TreeMap<Goliardia, Studente>();
		Map<String, List<Studente>>studentiPerCognome = new HashMap<String, List<Studente>>();
		Scanner s = null;
		Scanner stdin = null;
		try
		{
			s = new Scanner(new File(argv[0]));
			stdin = new Scanner(System.in);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			System.exit(1);
		}

		//List<Studente> list = new LinkedList<Studente>();
		List<Studente> list = new ArrayList<Studente>();
		while(s.hasNextLine())
		{
			Studente tmp = new Studente();
			tmp.popolaCampi(s);
			list.add(tmp);

			//matricola e' chiave univoca, aggiungo la coppia key,value
			studenti.put(new Integer(tmp.matricola), tmp);

			//goliardia e' chiave univoca, aggiungo la coppia key,value
			studentiPerGoliardia.put(tmp.gol, tmp);

			//cognome non e' una chiave univoca, uso coppie key, list<value>
			List<Studente> tmpList = studentiPerCognome.get(tmp.cognome);
			if(tmpList == null)
			{
				tmpList = new LinkedList<Studente>();
				studentiPerCognome.put(tmp.cognome, tmpList);
			}
			tmpList.add(tmp);
		}

		System.out.println(list);
		Collections.sort(list);
		System.out.println(list);
		Collections.sort(list, new ComparaStudentiPerCognomeNome());
		System.out.println(list);

		System.out.println(studenti);
		System.out.println(studentiPerCognome);
		System.out.println(studentiPerGoliardia);

		while(true)
		{
			System.out.print("Comando [cognome/matricola/goliardia/esci]? > ");
			String cmd = stdin.nextLine();
			if(cmd.equals("esci"))
			{
				break;
			}
			else if(cmd.equals("matricola"))
			{
				System.out.print("Matricola Studente? > ");
				Integer key = Integer.parseInt(stdin.nextLine());
				System.out.println("Associato alla matricola " + key + " ho lo studente: " + studenti.get(key));
			}
			else if(cmd.equals("goliardia"))
			{
				System.out.print("Goliardia Studente? > ");
				String key = stdin.nextLine();
				System.out.println("Di cognome " + key + " ho lo studente: " + studentiPerGoliardia.get(new Goliardia(key)));
			}
			else if(cmd.equals("cognome"))
			{
				System.out.print("Cognome Studente? > ");
				String key = stdin.nextLine();
				System.out.println("Di cognome " + key + " ho lo studente: " + studentiPerCognome.get(key));
			}
			else
			{
				System.out.println("Comando <" + cmd + "> non riconosciuto");
			}
		}
	}
}
